nss-ldapd.conf(5)

NAME
nss-ldapd.conf - configuration file for LDAP nameservice provider

DESCRIPTION
The nss-ldapd module allows LDAP directory servers to be used as a primary source of name service information. (Name service information typically includes users, hosts, groups, and other such data historically stored in flat files or NIS.)

The file \FCnss-ldapd.conf\F[] contains the configuration information for running nslcd (see nslcd(8)). The file contains options, one on each line, defining the way NSS lookups are mapped onto LDAP lookups.

OPTIONS

  RUNTIME OPTIONS

\FCthreads\F[] NUM
    Specifies the number of threads to start that can handle requests and perform LDAP queries. The default is to start 5 threads.

  GENERAL CONNECTION OPTIONS

\FCuri\F[] URI
    Specifies the LDAP URI of the server to connect to. The URI scheme may be ldap, ldapi or ldaps, specifying LDAP over TCP, ICP or SSL respectively (if supported by the LDAP library). Alternatively, the value DNS may be used to try to lookup the server using DNS SRV records. When using the ldapi scheme, %2f should be used to escape slashes (e.g. ldapi://%2fvar%2frun%2fslapd%2fldapi/), although most of the time this should not be needed. This option may be specified multiple times. Normally, only the first server will be used with the following servers as fall-back (see \FCbind_timelimit\F[] below). If LDAP lookups are used for host name resolution, any host names should be specified as an IP address or name that can be resolved without using LDAP.

\FCldap_version\F[] VERSION
    Specifies the version of the LDAP protocol to use. The default is to use the maximum version supported by the LDAP library.

\FCbinddn\F[] DN
    Specifies the distinguished name with which to bind to the directory server for lookups. The default is to bind anonymously.

\FCbindpw\F[] PASSWORD
    Specifies the clear text credentials with which to bind. This option is only applicable when used with \FCbinddn\F[] above. When binding to the directory using SASL or other authentication mechanisms apart from simple binds, this option is not used.

  KERBEROS AUTHENTICATION OPTIONS

\FCkrb5_ccname\F[] NAME
    Set the name for the GSS-API Kerberos credentials cache.

  SEARCH/MAPPING OPTIONS

\FCbase\F[] [MAP] DN
    Specifies the base distinguished name (DN) to use as search base. A global search base may be specified or a MAP-specific one. If no MAP-specific search base is defined the global one is used. If, instead of a DN, the value DOMAIN is specified, the hosts DNS domain is used to construct a basedn.

\FCscope\F[] [MAP] sub[tree]|one[level]|base
    Specifies the search scope (subtree, one level or base object). The default scope is subtree; base scope is almost never useful for name service lookups.

\FCderef\F[] never|searching|finding|always
    Specifies the policy for dereferencing aliases. The default policy is to never dereference aliases.

\FCreferrals\F[] yes|no
    Specifies whether automatic referral chasing should be enabled. The default behaviour is to chase referrals.

\FCfilter\F[] MAP FILTER
    The FILTER is an LDAP search filter to use for a specific map. The default filter is a basic search on the objectClass for the map (e.g. \FC(objectClass=posixAccount)\F[]).

\FCmap\F[] MAP ATTRIBUTE NEWATTRIBUTE
    This option allows for custom attributes to be looked up instead of the default RFC 2307 attributes. The MAP may be one of the supported maps below. The ATTRIBUTE is the one as used in RFC 2307 (e.g. \FCuserPassword\F[], \FCipProtocolNumber\F[] or \FCmacAddress\F[]). The NEWATTRIBUTE may be any attribute as it is available in the directory.

  TIMING/RECONNECT OPTIONS

\FCbind_timelimit\F[] SECONDS
    Specifies the time limit (in seconds) to use when connecting to the directory server. This is distinct from the time limit specified in \FCtimelimit\F[] and affects the setup of the connection only. Note that not all LDAP client libraries have support for setting the connection time out. The default \FCbind_timelimit\F[] is 30 seconds.

\FCtimelimit\F[] SECONDS
    Specifies the time limit (in seconds) to wait for a response from the LDAP server. A value of zero (0), which is the default, is to wait indefinitely for searches to be completed.

\FCidle_timelimit\F[] SECONDS
    Specifies the period if inactivity (in seconds) after which the connection to the LDAP server will be closed. The default is not to time out connections.

\FCreconnect_sleeptime\F[] SECONDS
    Specifies the number of seconds to sleep when connecting to all LDAP servers fails. By default 1 second is waited between the first failure and the first retry.

\FCreconnect_maxsleeptime\F[] SECONDS
    Specified the time after the last successful operation from which the LDAP server is considered permanently unavailable. Retries will be done only once in this time period. The default value is 30 seconds.

Note that the reconnect logic as described above is the mechanism that is used between nslcd and the LDAP server. The mechanism between the NSS client library and nslcd is simpler with a fixed compiled-in time out of a 10 seconds for writing to nslcd and a time out of 20 seconds for reading answers. nslcd itself has a read time out of 0.5 seconds and a write time out of 5 seconds.

  SSL/TLS OPTIONS

ssl <on|off|start_tls>
    Specifies whether to use SSL/TLS or not (the default is not to). If start_tls is specified then StartTLS is used rather than raw LDAP over SSL. Not all LDAP client libraries support both SSL and StartTLS, and all related configuration options.

sslpath <cert7_path>
    For the Netscape and Mozilla LDAP client libraries only, this specifies the path to the X.509 certificate database.

tls_checkpeer <yes|no>
    Specifies whether to require and verify the server certificate or not, when using SSL/TLS with the OpenLDAP client library. The default is to use the default behaviour of the client library; for OpenLDAP 2.0 and earlier it is "no", for OpenLDAP 2.1 and later it is "yes". At least one of tls_cacertdir and tls_cacertfile is required if peer verification is enabled.

tls_cacertdir <certificate_dir>
    Specifies the directory containing X.509 certificates for peer authentication.

tls_cacertfile <certificate_file>
    Specifies the path to the X.509 certificate for peer authentication.

tls_randfile <entropy_file>
    Specifies the path to an entropy source.

tls_ciphers <ciphers>
    Specifies the ciphers to use for TLS. See your TLS implementation's documentation for further information.

tls_cert <certificate_file>
    Specifies the path to the file containing the local certificate for client TLS authentication.

tls_key <key_file>
    Specifies the path to the file containing the private key for client TLS authentication.

  OTHER OPTIONS

\FCpagesize\F[] NUMBER
    Set this to a number greater than 0 to request paged results from the LDAP server in accordance with RFC2696. The default (0) is to not request paged results. This is useful for LDAP servers that contain a lot of entries (e.g. more than 500) and limit the number of entries that are returned with one request. For OpenLDAP servers you may need to set \FCsizelimit size.prtotal=unlimited\F[] for allowing more entries to be returned over multiple pages.

SUPPORTED MAPS
The following maps are supported. They are referenced as MAP in the options above.

alias[es]
    Mail aliases. Note that most mail servers do not use the NSS interface for requesting mail aliases and parse \FC/etc/aliases\F[] on their own.

ether[s]
    Ethernet numbers (mac addresses).

group
    Posix groups.

host[s]
    Host names.

netgroup
    Host and user groups used for access control.

network[s]
    Network numbers.

passwd
    Posix users.

protocol[s]
    Protocol definitions (like in \FC/etc/protocols\F[]).

rpc Remote procedure call names and numbers.

service[s]
    Network service names and numbers.

shadow
    Shadow user password information.

FILES

\FC/etc/nss-ldapd.conf\F[]
    the main configuration file

\FC/etc/nsswitch.conf\F[]
    Name Service Switch configuration file

SEE ALSO
nslcd(8), nsswitch.conf(5)

AUTHOR
This manual was written by Arthur de Jong <arthur@ch.tudelft.nl> and is based on the nss_ldap(5) manual developed by PADL Software Pty Ltd.

KNOWN BUGS
This manual page may be outdated and inaccurate and will be improved in upcoming releases. The features of nss-ldapd are still under development so these options may change in a future release.